'!TITLE "Weiss Robotics Griplink Constants"

'------------------------------------------------------------------------------------------------------------------
' GRIPLINK Plugin for Denso robots

' Author: Michael Teltscher
' Date: 2023-01-20
'------------------------------------------------------------------------------------------------------------------

#Pragma encrypt(on)

'Grip states
#define DS_NOT_CONNECTED 		0
#define DS_NOT_INITIALIZED 		1
#define DS_IDLE 				2
#define DS_RELEASED 			3
#define DS_NO_PART 				4
#define DS_HOLDING 				5
#define DS_PART_LOST 			6
#define DS_FAULT 				7

'Port numbers
#define GL_NUM_PORTS 			32 					'Refers to the number of ports, i.e. start counting with 1
#define GL_MAX_PORT 			(GL_NUM_PORTS - 1) 	'Refers to the highest index, i.e. start counting with 0

'Constants for MultiCommands
#define GL_MAX_PORT_MASK 		(2 ^ GL_NUM_PORTS) - 1 	'The maximum which a portMask of a MultiCommand can assume
#define GL_MIN_PORT_MASK 		1 						'The minimum which a portMask of a MultiCommand can assume
#define GL_DOUBLE_INT_DIVIDER 	3 						'Equals GL_MAX_PORT_MASK divided by the maximum an integer value can assume in pacScript (always rounded up!)

'Response limit
#define GL_RESPONSE_LIMIT 		15000 			'General time limit for responses (in milliseconds)

'Requirements on hardware and software
#define GL_PROTOCOL_ID 			"GRIPLINK" 		'The necessary protocol
#define GL_PROTOCOL_MIN_VERSION 1 				'The least recent required version of protocol

#Pragma encrypt(off)
